"
 (C) 2011 by Holger Hans Peter Freyther
 All Rights Reserved

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU Affero General Public License as
 published by the Free Software Foundation, either version 3 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Affero General Public License for more details.

 You should have received a copy of the GNU Affero General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
"

PackageLoader fileInPackage: 'Sockets'.

Object subclass: SIPBase64 [
    SIPBase64 class >> encode: aString [
        ^ (Base64LikeConverter mimeEncode: aString readStream) contents
    ]
]

Object subclass: SIPSecureRandom [
    <comment: 'I try to give some cryptographically secure random numbers'>

    SIPSecureRandom class >> nextByte [
        <category: 'random'>
        | file |
        file := FileDescriptor open: '/dev/random' mode: 'r'.
        [
            ^ file next value.
        ] ensure: [
            file close.
        ]
    ]

    SIPSecureRandom class >> nextInt [
        <category: 'random'>
        | file |
        file := FileDescriptor open: '/dev/random' mode: 'r'.
        [
            | data |
            data := ByteArray new: 4.
            1 to: data size do: [:each |
                data at: each put: file next value.
            ].

            ^ data uintAt: 1
        ] ensure: [
            file close.
        ]
    ]
]

Object subclass: SIPRandomHelper [
    <comment: 'I help with generating numbers'>

    SIPRandomHelper class >> generateTag [
        <category: 'random'>
        ^ SIPBase64 encode: '%1%2' % {
            DateTime now asSeconds. SIPSecureRandom nextInt}
    ]

    SIPRandomHelper class >> generateCallId [
        ^ '%1@%2' % {
            SIPBase64 encode: SIPSecureRandom nextInt asString.
            Sockets.SocketAddress localHostName.}
    ]
]
